$.fn.positionTransform = function() {
    var t = $(this), p = t.position();
    (t.css("-moz-transform") || "").replace(/matrix\(([^\)]+)\)/,
        function(str, mozmat) {
            var mozarr = mozmat.split(",");
            p.left += parseInt(mozarr[4]);
            p.top += parseInt(mozarr[5]);
    });
    return p;
};
$.fn.randomize = function(childElem) {
  return this.each(function() {
      var $this = $(this);
      var elems = $this.children(childElem);
			var works = $('#portfolio-works').children('.item');
			var keys = new Array();
			
			for (var k=0; k < elems.length; k++) {
				keys[k] = k;
			}
			
      keys.sort(function() { return (Math.round(Math.random())-0.5); });  

      $this.remove(childElem);
			$('#portfolio-works').remove('.item');
			
      for(var i=0; i < keys.length; i++) {
        $this.append(elems[keys[i]]);      
				$('#portfolio-works').append(works[keys[i]]);
			}
  });    
}

$(document).ready(function() {

	// jQuery tools tabs initialization (slider on main page)
	if ($('.slider-nav li').length) {
		
		$.tools.tabs.addEffect("slideHorizontal", function(tabIndex, done) {
			var panes = this.getPanes();
			  panes.show();
			  var panesW = new Array();
			  var tw = 0;
			  panesW[0] = 0;
			  panes.each( function(ind) {
			    $(this).css({'width': $(this).find('.tab-image img').width(), 'float': 'left', 'position': 'relative'});
			    tw += $(this).width();
			    panesW[ind+1] = tw;
		  });
			
			var container = panes.closest('.slides-wrap');
			
			// fix for centering slide
			var fix = panesW[1]-$('#main-slider').width();
			
			container.animate({'margin-left': -panesW[tabIndex]-fix/2}, 1000, function() {
				done.call();
			});
			
		});
		
		
		var sl_effect = 'fade';
		if	($('.wide #main-slider').length) {
			sl_effect = 'slideHorizontal';
			$(window).bind('resize', function() {
			  var cur = $('.wide #main-slider a.current').closest('li').index();
			  if (cur<0) cur=0;
  			$("ul.slider-nav").data('slideshow').stop();
  			$("ul.slider-nav").data('tabs').click(cur+1);
  			$("ul.slider-nav").data('slideshow').play();
			});
		}
		
		$("ul.slider-nav").tabs("#main-slider .tab", {
			effect: sl_effect,
			rotate: true,
			fadeInSpeed: 600,
			fadeOutSpeed: 300
		}).slideshow({
			autoplay: true,
			autopause: true,
			next: '.next',
			prev: '.prev'
		});
	
		
		$('#main-slider').thumbnailSlider({
			thumb_width	: 160,
			thumb_height: 66,
			speed		: 400
		});
		
		$('.slider-nav>li.item').click( function() {
		  $("ul.slider-nav").data('tabs').click($(this).index());
		  return false;
		});
	}
	
	// jQuery tools sidebar tabs initialization (tabs on sidebar)
	if ($('.sidebar-tabs-nav li').length) {
		$("ul.sidebar-tabs-nav").tabs(".sidebar-tabs>.tab");		
	}
	
	// placeholder for old browsers
	$('input[placeholder], textarea[placeholder]').placeholder();
	
	// validate forms 
	if ($('.custom-form').length) {
		$('.custom-form').validate();
	}
	
	// prettyPhoto
	if ('prettyPhoto' in $) {
	  $(".fancybox").prettyPhoto();
	}
	
	// menu navigation
	$('#header-nav>ul>li').hover(function() {
		if ($(this).find('ul').length) {
			$(this).addClass('sub');
			var tohide = $(this).next();
			while (tohide.length) {
				tohide.hide();
				tohide = tohide.next();
			}
		}
	}, function() {
		if ($(this).find('ul').length) {
  		$(this).removeClass('sub');
			var toshow = $(this).next();
			while (toshow.length) {
				toshow.show();
				toshow = toshow.next();
			}
		}
	});
	
	// portfolio sorter
	$('#works-sorter a').click( function() {  
		if ($(this).hasClass('current')) return false;
		
		var cc = $(this).attr('class');
		if (typeof cc != "string") return false;
		
		$('#works-sorter a.current').removeClass('current');
		// reset styles for tabs
		$('#portfolio-list li.preview, #portfolio-works>.item').removeAttr('style');
		$('#portfolio-list li.preview.current').removeClass('current');		
		
		
		if (cc.indexOf('web')+1) {
			$('#portfolio-list').isotope({ filter: '.web' });
		} else if (cc.indexOf('print')+1) {
			$('#portfolio-list').isotope({ filter: '.print' });
		} else if (cc.indexOf('branding')+1) {
			$('#portfolio-list').isotope({ filter: '.branding' });
		} else if (cc.indexOf('interactive')+1) {
			$('#portfolio-list').isotope({ filter: '.interactive' });
		} else if ($('#portfolio-list .preview').length) {
		  $('#portfolio-list').isotope({ filter: '.preview' });
		} else {
			$('#portfolio-list').isotope({ filter: '.view' });
		}
		
		if ($('#portfolio-list').data('tabs')) {
			$('#portfolio-list').data('tabs').destroy();
			$('#portfolio-list').data('tabs', false);
		}
		
		if ($('#portfolio-list .preview').length) {
			$('#portfolio-list .view').hide();		
			$('#portfolio-list .preview').each( function(num) {
				if ($(this).hasClass('disabled')) {
					$('#portfolio-works>.item:eq('+num+')').addClass('disabled');
				} else {
					$('#portfolio-works>.item:eq('+num+')').removeClass('disabled');
				}
			});
		}
		
		$(this).addClass('current');
		
		return false;			
	});
		
	// portfolio script
	if ($('#portfolio-works').length && $('#portfolio-list .preview').length) {
	  var works_list = $('#portfolio-list');
	  
		$('#portfolio-list').randomize('.preview');
		
	  works_list.isotope({
      itemSelector : '.preview',
      layoutMode : 'fitRows',
      hiddenClass : 'disabled',
			resizable: false,
		  animationOptions: {
				duration: 750,
				easing: 'linear',
				queue: false
  	  }
    });
	
		var works_view = $('#portfolio-works');
		
		works_view.appendTo('#portfolio-list .view')
		var works_item = $('#portfolio-list .view');
		works_item.hide();
		
		var rowHeight = $('#portfolio-list li.preview:visible:eq(0)').innerHeight()+parseInt($('#portfolio-list li.preview:visible:eq(0)').css('margin-bottom'));
		var viewHeight = 420;
		var viewMargin = 15;
		works_list.data('rowNum', 0);
		
		$.slideView = function(li) {			
			if (typeof li!='undefined') {
				var li= $(li);
				var current_item_top = li.positionTransform().top;
				var cur_top = works_item.positionTransform().top;
				var to_top = current_item_top+rowHeight+viewMargin;

				if (works_item.is(':visible')) {
					if (cur_top!=to_top) {
						$('#portfolio-list li.preview:not(.disabled)').each( function() {
							if (cur_top<to_top)
								var thistop = $(this).positionTransform().top+parseInt($(this).css('margin-top'))-viewHeight+rowHeight+viewMargin;
							else
								var thistop = $(this).positionTransform().top+parseInt($(this).css('margin-top'))+rowHeight;
							var thisanim = parseInt($(this).css('margin-top'));
							if (thistop>to_top) {
								if (thisanim!=viewHeight) {
									$(this).addClass('bef-animate');
								}
							} else if (thisanim==viewHeight) {
									$(this).addClass('aft-animate');
							}
						});
					}
				} else {
					var linum = li.index('#portfolio-list li.preview');
					$('.item:not(:eq('+linum+'))', works_view).hide();
					$('#portfolio-list li.preview:not(.disabled)').each( function() {
						var thistop = $(this).positionTransform().top;
						if (thistop>current_item_top) {
							$(this).addClass('bef-animate');
						}
					});
				}				
			} else{
				var to_top = 0;
				var cur_top = 0;
				var current_item_top = parseInt(works_item.css('top'));
				if (works_item.is(':visible')) {
					$('#portfolio-list li.preview:not(.disabled)').each( function() {
							var thistop = $(this).positionTransform().top+parseInt($(this).css('margin-top'))
							if (thistop>current_item_top) {
								$(this).addClass('aft-animate');
							}
						});					
				}
			}	

			var animate_top_margin = $('li.preview.bef-animate:not(.disabled)', works_list);
						
			var unanimate_top_margin = $('li.aft-animate:not(.disabled)', works_list);
			var startScr = $(window).scrollTop();		
				
			if (to_top!=cur_top && works_item.is(':visible')) {
				works_item.animate({'top': to_top}, {
					duration: 500,
					step: function(now, fx) {
						
						var progress = (fx.now-fx.start)/(fx.end-fx.start);
						
						animate_top_margin.css('margin-top', viewHeight*progress);
						unanimate_top_margin.css('margin-top', viewHeight*(1-progress));
						
						$(window).scrollTop(startScr+(to_top-startScr)*progress);
					},
					complete: function() {
						animate_top_margin.css('margin-top', viewHeight);
						unanimate_top_margin.css('margin-top', 0).removeClass('aft-animate');					
						unanimate_top_margin.each( function() {
							if ($(this).hasClass('temp-block')) {
								$(this).remove();
							}
						});
						$(this).css({'top': to_top});
						$('li.bef-animate', works_list).removeClass('bef-animate');
					}
				});
			} else if (!works_item.is(':visible')) {
				works_item.css({top: to_top});
				var works_list_height = works_list.height();
				works_list.css('height', works_list_height+viewHeight);
				works_item.css({display: 'block', height: 0, overflow: 'hidden'}).animate({'height': viewHeight},	{
					duration: 500,
					step: function(now, fx) {
						if (fx.end!=fx.start) {
							var progress = (fx.now-fx.start)/(fx.end-fx.start);
							animate_top_margin.css('margin-top', viewHeight*progress);							
						}
					},
					complete: function() {
						animate_top_margin.css('margin-top', viewHeight);
						works_list.css('height', works_list_height+viewHeight);
						$('li.bef-animate', works_list).removeClass('bef-animate');
					}
				});
			} else if (typeof li=='undefined') {
				var works_list_height = works_list.height();
				works_item.slideUp({
					duration: 500,
					step: function(now, fx) {
						if (fx.end!=fx.start) {
							var progress = (fx.now-fx.start)/(fx.end-fx.start);
							unanimate_top_margin.css('margin-top', viewHeight*(1-progress));
							works_list.css('height', works_list_height-viewHeight*progress);
						}
					},
					complete: function() {
						unanimate_top_margin.css('margin-top', 0).removeClass('aft-animate');
						works_list.css('height', works_list_height-viewHeight);
						$('#portfolio-list li.preview .current, #portfolio-list li.preview.current').removeClass('current');
					}
				});
			}
			
			if (!$('#portfolio-list').data('tabs')) {
				$('#portfolio-list').tabs('#portfolio-works>.item:not(.disabled)', {
					tabs: 'li.preview:not(.disabled) a',
					initialIndex: li.index('#portfolio-list li.preview:not(.disabled)'),
					effect: 'fade',
					fadeInSpeed: 600,
					fadeOutSpeed: 300
				});			
			}					
			var tabs_api = $('#portfolio-list').data('tabs');
			if (!$('a', li).hasClass('current')) {
				var linum = li.index('#portfolio-list li.preview:not(.disabled)');
				tabs_api.click(linum);		
			}
		};
		
		$('#portfolio-list li.preview a').live('click', function() {				
			var li = $(this).closest('li.preview');
			$.slideView(li);	
			$('#portfolio-list li.preview.current').removeClass('current');
			$(this).closest('li.preview').addClass('current');			
			
			return false;			
		});
		
		$('#portfolio-close').click( function() {
			$.slideView();
			return false;
		});
		
		$('#portfolio-next').click( function() {
			var cur = $('#portfolio-list li.preview.current').index('li.preview:not(.disabled)');
			var next = $('#portfolio-list li.preview:not(.disabled):eq('+(cur+1)+')');
			if (!next.length) {
				next = $('#portfolio-list li.preview:not(.disabled):eq(0)');
			}
			if (next.length) {
				next.children('a').trigger('click');
			}
			return false;
		});
		
		$('#portfolio-prev').click( function() {
			var cur = $('#portfolio-list li.preview.current').index('li.preview:not(.disabled)');
			if (cur>0) {
	  		var prev = $('#portfolio-list li.preview:not(.disabled):eq('+(cur-1)+')');
			} else {
				var prev = $('#portfolio-list li.preview:not(.disabled):last');
			}
			if (prev.length) {
				prev.children('a').trigger('click');
			}
			return false;
		});
	}
	
	
	// ie<8 fixes
	if ($.browser.msie && parseInt($.browser.version, 10)<8) {
		$('.content.white-shadow').wrap('<div class="ie7-container"></div>');
		$('.ie7-container').each( function() {
		  $(this).css({position: 'relative', overflow: 'visible', height: $(this).find('content.white-shadow').innerHeight() });
	  });
		$('.ie7-container .content.white-shadow').css('position', 'static');
		$('.ie7-container .content.white-shadow .shadow').each(function() {
		  $(this).appendTo($(this).closest('.ie7-container'));
		  $(this).css({top: $(this).closest('.ie7-container').innerHeight()});
		});		
		$('.ie7-container .content.white-shadow .content-top-button').each(function() {
		  $(this).appendTo($(this).closest('.ie7-container'));
		  $(this).css({top: $(this).closest('.ie7-container').innerHeight()-18});
		});
	}
	
});


// shortcodes scripts 
$(document).ready(function() {
	// shortcodes tabs
	if ($('.tabs-nav li').length) {
		$("ul.tabs-nav").tabs(".tabs-items>.item", {});
	}
	
	// toggle block 
	$('.toggle-item .toggle-title').bind('click', function() {
			if ($(this).is('.toggle-item')) {
				var $item = $(this);
			} else {
				var $item = $(this).closest('.toggle-item');
			}
			if ($item.hasClass('expanded')) {
				$item.animate({height: '33px'}, 400, function() {
					$(this).removeClass('expanded');
				});
			} else {
				$item.css('height', 'auto');
				var toh = $item.height();
				$item.css('height', '33px');
				$item.animate({height: toh}, 400, function() {
					$(this).addClass('expanded');
				});
			}
			return false;
	});

	// accordion
	if ($('.accordion-wrap' ).length) {
	  $('.accordion-wrap' ).accordion();
	}
	
	 
	if ($.browser.opera) {
		$('.rollover ul').addClass('sp_opera');
	  }
	if ($.browser.webkit) {
		$('.rollover ul').addClass('sp_mrg');
	  }	  
	if ($.browser.mozilla) {
		var v = parseInt($.browser.version);		
		if( v <= 4){		
			$('.rollover ul').addClass('sp_lisa_m4');
		}		
	}	 
	if ($.browser.msie) {	 
		if( $.browser.version < '9'){
				$('.rollover ul').addClass('sp_msie');
				$('#header').addClass('hd-pos');
			}else{$('.rollover ul').addClass('sp_msie9');}
			
	  }
	  
	  $('.image-links-container').jflickrfeed({
		limit: 4,
		qstrings: {
		id:'77451215@N02'
		},
		itemTemplate: '<a class="footer-image-link" href="{{image_b}}"><img src="{{image_s}}" alt="{{title}}" /></a>'
		});
	$('.wide #main-slider').hover(function(){		
		$('.slider-arrows').animate({opacity: 1}, 800 );
		
	},function(){
		$('.slider-arrows').animate({opacity: 0}, 800 );
		
	});
		

});	

